function [W, L, epsilon0] = ford(pya, pyc, cv, th, rn, lambda, abbe)
%
% FORD
%
%  Fourth-order wavefront aberrations
%
%

deln = zeros(size(rn));
if (nargin>6)
    idx = find(abbe);
    deln(idx) = (rn(idx)-1)./abbe(idx);
end

m = length(th);
epsilon0 = abs(lambda/(rn(m)*pya(m,2)));
L = rn(m).*(pya(m,1).*pyc(m,2)-pya(m,2).*pyc(m,1));
for (i=2:m)
  Ia(i) = rn(i)*(pya(i,2)+cv(i)*pya(i,1));
  Ic(i) = rn(i)*(pyc(i,2)+cv(i)*pyc(i,1));
  Ja(i) = pya(i,1)*(pya(i,2)/rn(i) - pya(i-1,2)/rn(i-1));
  Jc(i) = pya(i,1)*(pyc(i,2)/rn(i) - pyc(i-1,2)/rn(i-1));
  Jp(i) = cv(i)*(1.0/rn(i)-1.0/rn(i-1));
  Jw(i) = deln(i)/rn(i) - deln(i-1)/rn(i-1);
end
W040 = -Ia.*Ia.*Ja/(8*lambda);
W131 = -Ia.*Ic.*Ja/(2*lambda);
W222 = -Ic.*Ic.*Ja/(2*lambda);
W220 = -L*L*Jp/(4*lambda) + 0.5*W222;
W311 = -Ic.*(Ic.*Jc-pyc(1:m,1)'.*Jp*L)/(2*lambda);
WchA = Ia.*pya(1:m,1)'.*Jw/(2*lambda);
WchL = Ic.*pya(1:m,1)'.*Jw/lambda;
W = [W040' W131' W222' W220' W311' WchA' WchL'];
W(m+1,:) = sum(W);
